/*
   Projeto:
   Descrição:
   Autores:
   Data:
*/
#define botaoazul       6
#define botaovermelho   3
#define reledochuveiro  4
#define reledavalvula   5

//Variaveis pra guarda o valor se os botoes for apertado ou não
int botaoazulapertado;
int botaovermelhoapertado;

#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include <LiquidCrystal.h>
// Inicializa o display no endereco 0x27
LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);

unsigned long tempovalvula = 5000;
unsigned long tempochuveiro = 60000;
unsigned long tempoanterior = 0;

void setup() {
  Serial.begin(9600);
  lcd.begin (20, 4);
  
  pinMode( botaoazul,             INPUT);
  pinMode( botaovermelho,         INPUT);
  pinMode( reledavalvula,         OUTPUT);
  pinMode( reledochuveiro,        OUTPUT);
  
  //inicia a valvula e o chuveiro desligado
  digitalWrite (reledavalvula ,   LOW);
  digitalWrite (reledochuveiro,   LOW);
  delay(1000);
}

void loop() {

  unsigned long tempoatual = millis(); //VARIÁVEL RECEBE O TEMPO ATUAL EM MILIS

  lcd.setBacklight(HIGH);
  lcd.setCursor(0, 0);
  lcd.print("  Hora do banho !!");
  lcd.setCursor(0, 1);
  lcd.print("Qual o procedimento? ");
  delay(3000);
  lcd.clear();//Aqui é o comando para limpar o texto da tela
  lcd.setCursor(0, 1);
  lcd.print(" Vermelho ");
  lcd.setCursor(0, 2 );
  lcd.print(" Desliga");
  lcd.setCursor(10, 1);
  lcd.print("    Azul");
  lcd.setCursor(10, 2 );
  lcd.print("    Liga");

  while (botaoazul != HIGH or botaovermelho != HIGH) {
    botaoazulapertado = digitalRead(botaoazul);
    botaovermelhoapertado = digitalRead(botaovermelho);

    if (botaoazulapertado == HIGH) {
      lcd.clear();//Aqui é o comando para limpar o texto da tela

      lcd.setCursor(3, 1 );
      lcd.print("Tempo Restante:");
      digitalWrite (reledavalvula , HIGH);
      delay(3000);

      for (int tempo = 60; tempo >= 0; tempo--) {
        digitalWrite (reledochuveiro , HIGH);
        lcd.setCursor(5, 2 );
        lcd.print(tempo);
        lcd.print(" Segundos");
        delay(1000);
      }
      lcd.clear();//Aqui é o comando para limpar o texto da tela
      digitalWrite (reledavalvula , LOW);
      digitalWrite (reledochuveiro , LOW);
      break;
    }

    //Se o botão azul for apertado
    // liga a valvula e o Chuveiro
    else if (botaovermelhoapertado == HIGH) {
      Serial.println("BotaoVermelho Apertado");
      digitalWrite (reledavalvula , LOW);
      digitalWrite (reledochuveiro , LOW);
      lcd.clear();//Aqui é o comando para limpar o texto da tela
      lcd.setCursor(3, 2 );
      lcd.print("Acabou o Banho");
      // Deligar a valvula e o chuveiro
      // Acabou o banho
      delay(3000);
      lcd.clear();//Aqui é o comando para limpar o texto da tela
      lcd.setBacklight(LOW);// esse comando desliga a tela!
    }
  }

}
