/*
  Proejeto: Carrinho robô com Driver Ponte H L298N
  Data: 24/08/2019
  Autor: Cícero Henrique
  Descrição: Projeto de teste de robô com Driver Ponte H L298N
*/

//Definicoes pinos Arduino ligados a entrada da Ponte H
#define MOTOR_A 1
#define MOTOR_B 2
#define HORARIO true
#define ANTIHORARIO false
#define pino_do_sensor_de_chuva A0

int tempo_para_puchar_teto = 4000;
int valor_do_sensor_de_chuva;
boolean fechado = false;
boolean aberto = true;
boolean posicao_do_telhado = fechado;

void setup() {
  //Define os pinos como saida
  for (int i = 2; i < 8; i++) {
    pinMode(i, OUTPUT);
  }
  pinMode(pino_do_sensor_de_chuva, INPUT);
  Serial.begin(9600);
}

void loop() {
  //Lê o valor da porta do sensor e guarda na variavel de valor, depois mostra no monitor serial
  valor_do_sensor_de_chuva = analogRead(pino_do_sensor_de_chuva);
  Serial.println(valor_do_sensor_de_chuva);

  // Se o sensor detectar nivel médio à alto de chuva fecha o telhado
  if (valor_do_sensor_de_chuva >= 600 and valor_do_sensor_de_chuva <= 1024 and posicao_do_telhado == fechado) {
    //Inverte o valor do sensor de fechado para aberto
    posicao_do_telhado = !posicao_do_telhado;
    //Fecha o telhado
    //Gira o Motor A e B no sentido horario
    acionaMotor(MOTOR_A, HORARIO, 60);
    acionaMotor(MOTOR_B, HORARIO, 150);
    delay(tempo_para_puchar_teto);
  }
  // Se o sensor detectar nivel baixo à medio de chuva fecha o telhado
  else if (valor_do_sensor_de_chuva >= 0 and valor_do_sensor_de_chuva < 600 and posicao_do_telhado == aberto) {
    //Inverte o valor do sensor de aberto para fechado
    posicao_do_telhado = !posicao_do_telhado;
    //Abre o telhado
    //Gira o Motor A e B no sentido anti-horario
    acionaMotor(MOTOR_A, ANTIHORARIO, 60);
    acionaMotor(MOTOR_B, ANTIHORARIO, 150);
    delay(tempo_para_puchar_teto);
  }
  //Se as codições acima não forem verdadeiras verdadeiras os motores ficam parados
  else {
    //Para o motor A e B
    digitalWrite(2, HIGH);
    digitalWrite(4, HIGH);
    digitalWrite(6, HIGH);
    digitalWrite(7, HIGH);
    delay(2000);
  }
  //Espera 1 segundo para fazer a próxima leitura
  delay(2000);
}

//funcao para acionamento individual de cada motor
void acionaMotor(int motor, boolean sentido, int velocidade) {
  if (motor == MOTOR_A) {
    digitalWrite(2, sentido);
    digitalWrite(4, !sentido);
    analogWrite(3, velocidade);
  }
  else if (motor == MOTOR_B) {
    digitalWrite(6, !sentido);
    digitalWrite(7, sentido);
    analogWrite(5, velocidade);
  }
}
